
/*
 * Web Polygraph                        http://www.web-polygraph.org/
 * ------------------------------------------------------------------
 *
 *  Web Polygraph is copyrighted (C) 1998-2000 by The Regents of the
 *  University of California. See the COPYRIGHT file for details.
 */

#ifndef PG_CONNECTION_CLOSE_STATISTICS_H
#define PG_CONNECTION_CLOSE_STATISTICS_H

#include "xstd/Array.h"
#include "base/LogObj.h"
#include "base/histograms.h"

class ConnCloseStatItem;

// groups stats for all close kinds
class ConnCloseStat: public LogObj {
	public:
		typedef enum { ckBusy = 0, ckIdleLocal, ckIdleForeign, ckEnd } CloseKind;

	public:
		ConnCloseStat();
		virtual ~ConnCloseStat();

		void useHist(Log2Hist &acc) const; // totals
		void ttlHist(TimeHist &acc) const;
		const Log2Hist &useHist(int kind) const; // specifics
		const TimeHist &ttlHist(int kind) const;

		void record(CloseKind kind, Time ttl, int useCnt);
		void add(const ConnCloseStat &s);
		
		virtual OLog &store(OLog &ol) const;
		virtual ILog &load(ILog &il);

		ostream &print(ostream &os, const String &pfx) const;

	protected:
		Array<ConnCloseStatItem*> theStats;
};

#endif
