
/*
 * Web Polygraph                        http://www.web-polygraph.org/
 * ------------------------------------------------------------------
 *
 *  Web Polygraph is copyrighted (C) 1998-2000 by The Regents of the
 *  University of California. See the COPYRIGHT file for details.
 */

#ifndef PG_CONTENT_TYPE_STATISTICS_H
#define PG_CONTENT_TYPE_STATISTICS_H

#include "xstd/Array.h"
#include "base/LogObj.h"

class String;
class AggrStat;

// groups stats for all close kinds
class ContTypeStat: public LogObj {
	public:
		static void RecordKind(int ctype, const String &kind);
		static const Array<String*> &Kinds() { return TheKinds; }
		static void Store(OLog &ol);
		static void Load(ILog &il);

	public:
		ContTypeStat();
		virtual ~ContTypeStat();

		AggrStat &stats(int idx) const { return *theStats[idx]; }

		void record(int ctype, Size sz);
		void add(const ContTypeStat &s);
		
		virtual OLog &store(OLog &ol) const;
		virtual ILog &load(ILog &il);

		ostream &print(ostream &os, const String &pfx) const;

	protected:
		static Array<String*> TheKinds;

	protected:
		Array<AggrStat*> theStats;
};

#endif
