
/*
 * Web Polygraph                        http://www.web-polygraph.org/
 * ------------------------------------------------------------------
 *
 *  Web Polygraph is copyrighted (C) 1998-2000 by The Regents of the
 *  University of California. See the COPYRIGHT file for details.
 */

#ifndef PGL_INT_SYMBOL_H
#define PGL_INT_SYMBOL_H

#include "pgl/PglExprSym.h"

class IntSym: public ExpressionSym {
	public:
		static IntSym *Fit(const String &op, double d, const TokenLoc &);

	public:
		IntSym(int aVal);

		int val() const { return theVal; }
		void val(int v) { theVal = v; }

		virtual bool isA(const String &type) const;

		virtual ExpressionSym *unOper(const String &op) const;
		virtual ExpressionSym *bnOper(const String &op, const SynSym &exp) const;

		virtual ostream &print(ostream &os, const String &pfx = 0) const;

	protected:
		virtual SynSym *dupe(const String &dType) const;
		IntSym *fit(const String &op, double d) const;
		ExpressionSym *operRange(int otherEnd) const;

	protected:
		int theVal;
};

#endif
