
/*
 * Web Polygraph                        http://www.web-polygraph.org/
 * ------------------------------------------------------------------
 *
 *  Web Polygraph is copyrighted (C) 1998-2000 by The Regents of the
 *  University of California. See the COPYRIGHT file for details.
 */

#ifndef PGL_STRING_RANGE_SYMBOL_H
#define PGL_STRING_RANGE_SYMBOL_H

#include "pgl/PglContainerSym.h"

class PglStrRange;

// a compact representation of a range of strings
class StrRangeSym: public ContainerSym {
	public:
		StrRangeSym();
		virtual ~StrRangeSym();

		virtual bool isA(const String &type) const;

		virtual int count() const;
		virtual bool probsSet() const;
		virtual const SynSym *itemProb(int offset, double &prob) const;

		void range(PglStrRange *aRange) { theRange = aRange; }

		virtual ostream &print(ostream &os, const String &pfx) const;

	protected:
		virtual SynSym *dupe(const String &type) const;

	protected:
		PglStrRange *theRange;
		mutable StringSym *theStr; // cache for itemProb()
};

#endif
